function s=stabExtra1(z,n)
%z=-100;
%n=1:7;

k=length(n);
%for ii=1:length(n)
%    S(ii)=(1+z/n(ii))^n(ii);
%end
S=(1+z./n).^n;

%my implementation
for ll=2:k %for all columns
    %k-ll+2
    for ii=2:k-ll+2 %for all lines
       % keyboard
        S(ii-1)=S(ii)+(S(ii)-S(ii-1))/(n(ii+ll-2)/n(ii-1)-1);
    end
end
s=S(1);

% %naive implementation
% Stemp=zeros(k,k);
% Stemp(:,1)=((1+z./n).^n)';
% for ll=2:k %for all columns
%     for ii=ll:k %for all lines        
%         Stemp(ii,ll)=Stemp(ii,ll-1)+(Stemp(ii,ll-1)-Stemp(ii-1,ll-1))...
%             /(n(ii)/n(ii-ll+1)-1);
%     end
% end
% Stemp(end,end);


% %Slides implementation
% T(1) = (1+z/n(1))^(1);
% for i=2:k
%     T(i) = (1+z/n(i))^n(i);
%     for l=i-1:-1:1
%         T(l)=T(l+1)+(T(l+1)-T(l))/...
%             ( n(i)/n(l)-1);
%     end
% end
% T(1)
%keyboard

end