%plot the stability domain of the extrapolated explicit Euler scheme

function stabExtra2

%
n=1:5;

% Baue Matrizen X und Y mit meshgrid hier auf:
[X,Y] = meshgrid(-5:0.1:5);

%Erzeuge komplexe Gitter
Z = X + 1i*Y;
  
%Evaluiere die Stabilitaetsfunction S auf dem Gitter Z
Sz=zeros(size(Z));
for ii=1:length(Z)
    for jj=1:length(Z)
        Sz(ii,jj)=stabExtra1(Z(ii,jj),n);
    end
end
 
figure;
% Ruf contourf() mit Niveaulinien abs(S) = [0 1 2 5] hier auf:
[~,h] =contourf(X,Y,abs(Sz), [0 1 2 5]);
set(h,'ShowText','on','TextStep',get(h,'LevelStep'));
colormap(autumn);
colorbar

%title(['Stability Domain for the Theta-Method, \theta = ' num2str(theta)]);
xlabel('Re');
ylabel('Im');
axis square;
grid on;

end
